
<!DOCTYPE html>
<html>
<head>
    <title>INF226</title>
    <link rel="stylesheet" href="highlight.css" />
	<link rel="icon" href="favicon.png" type="image/png" />
    <style>
        * {
            box-sizing: border-box;
            ;
        }

        #page {
            height: 100vh;
            display: flex;
            flex-direction: column;
            ;
            padding: .5rem;
        }

        main {
            border-top: 1px solid grey;
            border-bottom: 1px solid grey;
            /* min-height: 50%; */
            flex-grow: 1;
            flex-shrink: 1;
            overflow:auto;
        }

        body {
            margin: 0;
        }

        label {
            justify-self: end;
            ;
        }

        #controls {
            /* min-height: 20%; */
            font-size: 1.4rem;
            display: grid;
            grid-template-columns: 1fr 6fr 1fr 1fr;
            grid-auto-rows: 1.4rem;
            ;
            grid-gap: .5rem;
            max-width: 70rem;

        }

        #output {
            width: 100%;
            height: 100%;
            background: #eee;
            overflow: auto;
            margin: 0;
        }
        #output p {
            border-bottom: 1px solid grey;
            padding-bottom: .25rem;
        }
        #header {
            display: flex;
            flex-direction: row;
            flex-wrap: wrap;
        }

        #header li {
            display: block;
            font-style: italic;
            font-size: 1.2rem;
            padding: .25rem;
            margin:0 1rem;
        }
    </style>

</head>

<body>
    <div id="page">
        <marquee>
            <div id="header"></div>
        </marquee>
        <main>
            <pre id="output"></pre>
        </main>
        <div id="controls">
            <label for="search">Search:</label>
            <input type="search" id="search" name="search" enterkeyhint="search" value="*">
            <button type="button" id="searchBtn">Search!</button>
            <button type="button" id="allBtn">Show all</button>
            <button type="button" id="logOut">Log out</button>
            <button type="button" id="myChats">My chats</button>
            <button type="button" id="newChat">Create new chat</button>
            <input type="text" id="chatID" name="chatID" value="chatID">
            <button type="button" id="sendBtn">Send</button>
            <textarea id="message" style="grid-row: span 4;">A message...</textarea>
        </div>
        <div id="anchor"></div>
    </div>
</body>
<script>
    // Token used to protect against CSRF attacks
    var csrfToken = "{{ csrf_token() }}"
    var reqId = 0;
    var anchor = document.getElementById('anchor');
    var searchField = document.getElementById('search');
    var senderField = document.getElementById('sender');
    var chatID = document.getElementById('chatID');
    var messageField = document.getElementById('message');
    var searchBtn = document.getElementById('searchBtn');
    var sendBtn = document.getElementById('sendBtn');
    var allBtn = document.getElementById('allBtn');
    var logOut = document.getElementById('logOut');
    var myChats = document.getElementById('myChats');
    var newChat = document.getElementById('newChat')
    var output = document.getElementById('output');
    var header = document.getElementById('header');

    var checkAnnouncements = async () => {
        res = await fetch('/announcements');
        anns = await res.json();
        if (anns && Array.isArray(anns.data)) {
            const elts = [];
            anns.data.forEach((element, idx) => {
                if (idx > 0) {
                    const node = document.createElement('li');
                    node.textContent = '  …  ';
                    elts.push(node);
                }
                const node = document.createElement('li');
                node.textContent = `${element.message || ''}`;
                elts.push(node);
            });
            console.log(elts);
            header.replaceChildren(...elts);
        }
    };
    var search = async (query, chatID) => {
        console.log(csrfToken)
        const id = reqId++;
        const q = `/search?q=${encodeURIComponent(query)}&chatID=${encodeURIComponent(chatID)}`;
        res = await fetch(q);
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = `[${id}]  ${q} → ${res.status} ${res.statusText}`;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };
    var send = async (chatID, message) => {
        const id = reqId++;
        const q = `/send?chatID=${encodeURIComponent(chatID)}&message=${encodeURIComponent(message)}`;
        res = await fetch(q, { method: 'post', headers: { "X-CSRFToken": csrfToken}} );
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = `[${id}]  ${q} → ${res.status} ${res.statusText}`;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };
    var logout = async () => {
        const id = reqId++;
        const q = '/logout'
        res = await fetch(q, { headers: { "X-CSRFToken": csrfToken}});
        console.log(res);
        location.reload(); // This realoads the page, thus sending us to where the fetch has redirected us...
    }
    var getchats = async () => {
        const id = reqId++;
        const q = '/mychats';
        console.log('test');
        res = await fetch(q);
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = `[${id}]  ${q} → ${res.status} ${res.statusText}`;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();

    }
    var newchat = async (name, users) => {
        const id = reqId++;
        const q = `/newchat?chatname=${encodeURIComponent(name)}&users=${encodeURIComponent(users)}`;
        res = await fetch(q, { method: 'post', headers: { "X-CSRFToken": csrfToken}});
        console.log(res);

    }

    searchField.addEventListener('keydown', ev => {
        if (ev.key === 'Enter') {
            search(searchField.value, chatID.value);
        }
    });
    searchBtn.addEventListener('click', () => search(searchField.value, chatID.value));
    logOut.addEventListener('click', () => logout());
    allBtn.addEventListener('click', () => search('*', ''));
    sendBtn.addEventListener('click', () => send(chatID.value, messageField.value));
    myChats.addEventListener('click', () => getchats());
    newChat.addEventListener('click', () => newchat(searchField.value, messageField.value));
    checkAnnouncements();
</script>

</html>